/* 
    Date Created: May 06, 2010
    FileName: main.cpp

    First Sprite Example 
*/

#include "./source/inc/GOC.h"
#include "./source/PlatformSpecific/inc/DeviceInput.h"

void GOC::Initialize()
{
    /* 
        Initialize your game scene, and game variables here. 
    */
    
    tempTimer_m = new TimerGOC();

    testPosition_m.xCor_m = 0.0f;
    testPosition_m.yCor_m = 0.0f;
    testPosition_m.zCor_m = 0.0f;

    testSprite_m = new Sprite();
    testSprite_m->Set2DPosition(testPosition_m,
                                64,
                                64);
    testSprite_m->GetTexture()->LoadTexture("./images/Ship.png");
    testSprite_m->SetVisible(false);

    shipPosition_m.xCor_m = 1.0f;
    shipPosition_m.yCor_m = 1.0f;
    shipPosition_m.zCor_m = 0.0f;

    shipAnimation_m = new AnimationGOC();
    shipAnimation_m->InitiliseAnimation("./images/Ship.png", // Animation strip.
                                        5,                   // Number of frames.
                                        64,                  // Frame width.
                                        64,                  // Frame height.
                                        2,                   // Starting row.
                                        1);                  // Starting colom.
    shipAnimation_m->Set2DPosition(shipPosition_m, // Position.
                                   128,            // Width.
                                   128);           // Height.
    
    shipAnimation_m->SetVisible(true);    
}

void GOC::Update(TimeGOC *timeGOC_p, InputEngine *input_p)
{
    /* 
        Update your game scenes, check for collisions, check for input
        and play sounds here.
    */
}

void GOC::IndependentUpdate(TimeGOC *timeGOC_p, InputEngine *input_p)
{
    /* 
        Update your game scenes, check for collisions, check for input
        and play sounds here.
    */
    shipAnimation_m->StartAnimation(13, timeGOC_p);    
}

void GOC::Destroy()
{
    /* 
        Clean up after your game here.
    */
    delete shipAnimation_m;

    delete testSprite_m;    
}

#ifdef _WIN32
    // Define the windows main funciton.
    int WINAPI WinMain(HINSTANCE hInstance, 
                       HINSTANCE hPrevInstance, 
                       LPSTR lpCmdLine, 
                       int nCmdShow)
#else
    // Define the ubutnu main function.
    int main(int argc, char **argv)
#endif
    {
        #ifdef _WIN32
            // Start the GOC on windows.
            GOC::goc_i()->LoadGOC(hInstance);
        #else
            // Start the GOC on ubuntu.
            GOC::goc_i()->LoadGOC();
        #endif
   
        return 0;
    } 


